----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:43:40 07/31/2014 
-- Design Name: 
-- Module Name:    Counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Counter is
	generic (N : integer := 8);
   Port 
	( 
		clk : in  STD_LOGIC;
      clr : in  STD_LOGIC;
      q : out  STD_LOGIC_VECTOR (N-1 downto 0)
	);
end Counter;

architecture Behavioral of Counter is

	signal count : STD_LOGIC_VECTOR(N-1 downto 0);

begin

	process(clk, clr)
	begin
		if clr = '1' then
			count <= (others => '0');
		elsif rising_edge(clk) then
			count <= count + 1;
		end if;
	end process;
	
	q <= count;

end Behavioral;
