----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:39:07 07/31/2014 
-- Design Name: 
-- Module Name:    CounterTop - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity CounterTop is
    Port ( clk : in  STD_LOGIC;
           clr : in  STD_LOGIC;
           Led : out  STD_LOGIC_VECTOR (7 downto 0));
end CounterTop;

architecture Behavioral of CounterTop is

	component Counter
		generic (N : positive := 8);
		port
		(	
			clk : in  STD_LOGIC;
			clr : in  STD_LOGIC;
			q   : out  STD_LOGIC_VECTOR (N-1 downto 0)
		);
	end component;
	
	component CLKCounter
		port
		(	
			clk_in  : in  STD_LOGIC;
			clr	  : in  STD_LOGIC;
			clk_out : out  STD_LOGIC
		);
	end component;
	
	signal clk_signal : STD_LOGIC;

begin

	CNT : Counter
	generic map (N => 8)
	port map
	(
		clk => clk_signal,
		clr => clr,
		q   => Led
	);
	
	CLKC : CLKCounter
	port map
	(
		clk_in  => clk,
		clr     => clr,
		clk_out => clk_signal
	);

end Behavioral;

